<?php
// wcf imports
require_once(WCF_DIR.'lib/system/event/EventListener.class.php');

/**
 * Listen to the status save action to close/open latest posts and threads boxes.
 * 
 * @author 	Nerd Almighty
 * @copyright	2009 Bergwerk <http://bergwerk.forenberg.de>
 * @license	Creative Commons - Attribution-Noncommercial-Share Alike 3.0 Unported <http://creativecommons.org/licenses/by-nc-sa/3.0/>
 * @package	com.bergwerk.wbb.page.user.latestPostsAndThreads
 * @subpackage	system.event.listener
 * @category 	Burning Board
 */
class StatusSaveActionLatestPostsAndThreadsListListener implements EventListener {
	/**
	 * @see EventListener::execute()
	 */
	public function execute($eventObj, $className, $eventName) {
		if (preg_match('/^latestPostsAndThreadsBox(\d+)$/', $eventObj->name, $match)) {
			$boxID = $match[1];			
			$status = $eventObj->status;
			
			// get list status
			if (WCF::getUser()->userID) $allClosedBoxes = (strlen(WCF::getUser()->latestPostsAndThreadsBoxClosed) ? explode(',', WCF::getUser()->latestPostsAndThreadsBoxClosed) : array());
				else $allClosedBoxes = (strlen(WCF::getSession()->getVar('latestPostsAndThreadsBoxClosed')) ? explode(',', WCF::getSession()->getVar('latestPostsAndThreadsBoxClosed')) : array());
			if ($status != !in_array($boxID, $allClosedBoxes)) {
				// update status
				if ($status) {
					// open
					$key = array_search($boxID, $allClosedBoxes);
					unset($allClosedBoxes[$key]);
				}
				else {
					// close
					$allClosedBoxes[] = $boxID;
				}
				WCF::getUser()->saveStatus('latestPostsAndThreadsBoxClosed', implode(',', $allClosedBoxes));
			}
			exit;
		}
	}
}
?>